// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.List;
import java.util.Map;
import org.andromda.metafacades.uml.FrontEndAction;

/**
 * <p>
 * Represents an action taken during a "front-end" event execution
 * on a JSF application.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFAction
    extends FrontEndAction
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFActionMetaType();

    /**
     * <p>
     * The name of the action class that executes this action.
     * </p>
     * @return String
     */
    public String getActionClassName();

    /**
     * <p>
     * The name of the action on the controller that executions this
     * action.
     * </p>
     * @return String
     */
    public String getControllerAction();

    /**
     * <p>
     * A resource message key suited for the action''s documentation.
     * </p>
     * @return String
     */
    public String getDocumentationKey();

    /**
     * <p>
     * The resource messsage value suited for the action''s
     * documentation.
     * </p>
     * @return String
     */
    public String getDocumentationValue();

    /**
     * <p>
     * The name of the bean under which the form is stored.
     * </p>
     * @return String
     */
    public String getFormBeanName();

    /**
     * <p>
     * The signature of the accessor method that returns the form
     * implementation instance.
     * </p>
     * @return String
     */
    public String getFormImplementationGetter();

    /**
     * <p>
     * A comma separated list of all the form interfaces which the form
     * implementation implements.
     * </p>
     * @return String
     */
    public String getFormImplementationInterfaceList();

    /**
     * <p>
     * The name of the form implementation.
     * </p>
     * @return String
     */
    public String getFormImplementationName();

    /**
     * <p>
     * The key that stores the form in which information is passed from
     * one action to another.
     * </p>
     * @return String
     */
    public String getFormKey();

    /**
     * <p>
     * The scope of the JSF form (request, session,application,etc).
     * </p>
     * @return String
     */
    public String getFormScope();

    /**
     * <p>
     * The calcuated serial version UID for this action's form.
     * </p>
     * @return String
     */
    public String getFormSerialVersionUID();

    /**
     * <p>
     * The name that corresponds to the from-outcome in an navigational
     * rule.
     * </p>
     * @return String
     */
    public String getFromOutcome();

    /**
     * <p>
     * The fully qualified name of the action class that execute this
     * action.
     * </p>
     * @return String
     */
    public String getFullyQualifiedActionClassName();

    /**
     * <p>
     * The fully qualified path to the action class that execute this
     * action.
     * </p>
     * @return String
     */
    public String getFullyQualifiedActionClassPath();

    /**
     * <p>
     * The fully qualified name of the form implementation.
     * </p>
     * @return String
     */
    public String getFullyQualifiedFormImplementationName();

    /**
     * <p>
     * The fully qualified path of the form implementation.
     * </p>
     * @return String
     */
    public String getFullyQualifiedFormImplementationPath();

    /**
     * <p>
     * All parameters that are of hidden input type.
     * </p>
     * @return List<JSFParameter>
     */
    public List<JSFParameter> getHiddenParameters();

    /**
     * <p>
     * The default resource message key for this action.
     * </p>
     * @return String
     */
    public String getMessageKey();

    /**
     * <p>
     * The path to this action.
     * </p>
     * @return String
     */
    public String getPath();

    /**
     * <p>
     * The path's root.
     * </p>
     * @return String
     */
    public String getPathRoot();

    /**
     * <p>
     * Messages used to indicate successful execution.
     * </p>
     * @return Map
     */
    public Map getSuccessMessages();

    /**
     * <p>
     * The name of the column targetted by this action.
     * </p>
     * @return String
     */
    public String getTableLinkColumnName();

    /**
     * <p>
     * The name of the table link specified for this action.
     * </p>
     * @return String
     */
    public String getTableLinkName();

    /**
     * <p>
     * If the action is a table link then this property represents the
     * table to which is being linked.
     * </p>
     * @return JSFParameter
     */
    public JSFParameter getTableLinkParameter();

    /**
     * <p>
     * The name of the method to be executed when this action is
     * triggered.
     * </p>
     * @return String
     */
    public String getTriggerMethodName();

    /**
     * <p>
     * The name of the trigger that triggers that action.
     * </p>
     * @return String
     */
    public String getTriggerName();

    /**
     * <p>
     * The path to the view fragment corresponding to this action
     * </p>
     * @return String
     */
    public String getViewFragmentPath();

    /**
     * <p>
     * Any messages used to indicate a warning.
     * </p>
     * @return Map
     */
    public Map getWarningMessages();

    /**
     * <p>
     * Indicates whether or not a final state is the target of this
     * action.
     * </p>
     * @return boolean
     */
    public boolean isFinalStateTarget();

    /**
     * <p>
     * Whether or not the entire form should be reset (all action
     * parameters on the form).
     * </p>
     * @return boolean
     */
    public boolean isFormReset();

    /**
     * <p>
     * Indicates if at least one parameter on the form requires being
     * reset.
     * </p>
     * @return boolean
     */
    public boolean isFormResetRequired();

    /**
     * <p>
     * Indicates whether or not this action is represented by clicking
     * on a hyperlink.
     * </p>
     * @return boolean
     */
    public boolean isHyperlink();

    /**
     * 
     * @return boolean
     */
    public boolean isNeedsFileUpload();

    /**
     * <p>
     * Indicates if this action forwards to a popup (this is determed
     * when the targetted view is a popup).
     * </p>
     * @return boolean
     */
    public boolean isPopup();

    /**
     * <p>
     * Indicates whether or not the values passed along with this
     * action can be reset or not.
     * </p>
     * @return boolean
     */
    public boolean isResettable();

    /**
     * <p>
     * Indicates whether or not any success messags are present.
     * </p>
     * @return boolean
     */
    public boolean isSuccessMessagesPresent();

    /**
     * <p>
     * Indicates that this action works on all rows of the table from
     * the table link relation.
     * </p>
     * @return boolean
     */
    public boolean isTableAction();

    /**
     * <p>
     * Indicates if a table link name has been specified and it
     * properly targets a table page-variable from the input page.
     * </p>
     * @return boolean
     */
    public boolean isTableLink();

    /**
     * <p>
     * Indicates whether or not at least one parameter on this action
     * requires validation.
     * </p>
     * @return boolean
     */
    public boolean isValidationRequired();

    /**
     * <p>
     * Whether or not any warning messages are present.
     * </p>
     * @return boolean
     */
    public boolean isWarningMessagesPresent();
}