// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.AttributeFacade;
import org.andromda.metafacades.uml.FrontEndParameter;
import org.andromda.metafacades.uml.ParameterFacade;

/**
 * <p>
 * Represents an attribute on a classifier used by a JSF
 * application.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFAttribute
    extends AttributeFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFAttributeMetaType();

    /**
     * <p>
     * Gets backing list name for this attribute. This is useful if you
     * want to be able to select the attribute value from a list (i.e.
     * a drop-down select input type).
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getBackingListName(ParameterFacade ownerParameter);

    /**
     * <p>
     * Constructs and returns the backing value name given the
     * 'ownerParameter'.
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getBackingValueName(ParameterFacade ownerParameter);

    /**
     * <p>
     * Gets the name of the date formatter for this attribute by
     * constructing the name from the 'ownerParameter' (if this
     * attribute represents a date).
     * </p>
     * @param ownerParameter JSFParameter
     * @return String
     */
    public String getDateFormatter(JSFParameter ownerParameter);

    /**
     * <p>
     * The dummy value to give the attribute when creating a dummy
     * instance of this attribute's owner.
     * </p>
     * @return String
     */
    public String getDummyValue();

    /**
     * <p>
     * Gets the unique id of this attribute on the form.
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getFormPropertyId(ParameterFacade ownerParameter);

    /**
     * <p>
     * Retrieves the name of the form property for this attribute by
     * taking the name of the owner property.
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getFormPropertyName(ParameterFacade ownerParameter);

    /**
     * <p>
     * If this attributes represents a date or time this method will
     * return the format in which it must be represented. In the event
     * this format has not been specified by the any tagged value the
     * default will be used.
     * </p>
     * @return String
     */
    public String getFormat();

    /**
     * <p>
     * A comma separated list of the input table identifier columns
     * (these are the columns that uniquely define a row in an input
     * table).
     * </p>
     * @return String
     */
    public String getInputTableIdentifierColumns();

    /**
     * <p>
     * Gets the name of the label list for this parameter. The label
     * list name is the name of the list storing the labels for the
     * possible values of this attribute (typically used for the labels
     * of a drop-down select lists).
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getLabelListName(ParameterFacade ownerParameter);

    /**
     * <p>
     * The max length allowed in the input component
     * </p>
     * @return String
     */
    public String getMaxLength();

    /**
     * <p>
     * The message key for this attribute.
     * </p>
     * @return String
     */
    public String getMessageKey();

    /**
     * <p>
     * The default value for the message key.
     * </p>
     * @return String
     */
    public String getMessageValue();

    /**
     * <p>
     * Gets the name of the time formatter (if this parameter
     * represents a time).
     * </p>
     * @param ownerParameter JSFParameter
     * @return String
     */
    public String getTimeFormatter(JSFParameter ownerParameter);

    /**
     * <p>
     * The validator's 'validwhen' value, this is useful when the
     * validation of a parameter depends on the validation of others.
     * See the apache commons-validator documentation for more
     * information.
     * </p>
     * @return String
     */
    public String getValidWhen();

    /**
     * <p>
     * Gets the arguments for this parameter's validators.
     * </p>
     * @param validatorType String
     * @return Collection
     */
    public Collection getValidatorArgs(String validatorType);

    /**
     * <p>
     * All validator types for this attribute.
     * </p>
     * @return Collection
     */
    public Collection getValidatorTypes();

    /**
     * <p>
     * Gets the validator args for this attribute
     * </p>
     * @param ownerParameter JSFParameter
     * @return Collection
     */
    public Collection getValidatorVars(JSFParameter ownerParameter);

    /**
     * <p>
     * The dummy value for a value list.
     * </p>
     * @return String
     */
    public String getValueListDummyValue();

    /**
     * <p>
     * Gets the name of the value list for this parameter; this list
     * stores the possible values that this attribute may be (typically
     * used for the values of a drop-down select list).
     * </p>
     * @param ownerParameter ParameterFacade
     * @return String
     */
    public String getValueListName(ParameterFacade ownerParameter);

    /**
     * <p>
     * Indicates whether or not the backing value is required for this
     * attribute (depending on the 'ownerParameter').
     * </p>
     * @param ownerParameter FrontEndParameter
     * @return boolean
     */
    public boolean isBackingValueRequired(FrontEndParameter ownerParameter);

    /**
     * <p>
     * Indicates whether or not this parameter uses the equal
     * validator.
     * </p>
     * @return boolean
     */
    public boolean isEqualValidator();

    /**
     * <p>
     * Indicates if this parameter represents a checkbox widget.
     * </p>
     * @return boolean
     */
    public boolean isInputCheckbox();

    /**
     * <p>
     * Indicates whether or not this is a file input type.
     * </p>
     * @return boolean
     */
    public boolean isInputFile();

    /**
     * <p>
     * Indicates whether or not this parameter represents a hidden
     * input widget.
     * </p>
     * @return boolean
     */
    public boolean isInputHidden();

    /**
     * <p>
     * Indicates whether or not this type represents an input multibox.
     * </p>
     * @return boolean
     */
    public boolean isInputMultibox();

    /**
     * <p>
     * Indicates whether or not this parameter should be rendered as an
     * input radio widget.
     * </p>
     * @return boolean
     */
    public boolean isInputRadio();

    /**
     * <p>
     * Indicates whether or not this parameter represents an input
     * "secret" widget (i.e. password).
     * </p>
     * @return boolean
     */
    public boolean isInputSecret();

    /**
     * <p>
     * Indicates whether or not this parameter represents an input
     * select widget.
     * </p>
     * @return boolean
     */
    public boolean isInputSelect();

    /**
     * <p>
     * Indicates whether or not this is an table input type.
     * </p>
     * @return boolean
     */
    public boolean isInputTable();

    /**
     * <p>
     * Indicates whether or not this parameter should be rendered as a
     * text input widget.
     * </p>
     * @return boolean
     */
    public boolean isInputText();

    /**
     * <p>
     * Indicates if this parameter represents as an input text area
     * widget.
     * </p>
     * @return boolean
     */
    public boolean isInputTextarea();

    /**
     * <p>
     * Indicates whether or not there is an input type defined for this
     * attribute.
     * </p>
     * @return boolean
     */
    public boolean isInputTypePresent();

    /**
     * <p>
     * Indicates whether or not this attribute's value should be
     * rendered as plain text (not as a widget).
     * </p>
     * @return boolean
     */
    public boolean isPlaintext();

    /**
     * <p>
     * Indicates whether or not this attribute is selectable according
     * to its 'ownerParameter'.
     * </p>
     * @param ownerParameter FrontEndParameter
     * @return boolean
     */
    public boolean isSelectable(FrontEndParameter ownerParameter);

    /**
     * <p>
     * Indicates where or not the date format is to be strictly
     * respected. Otherwise the date formatter used for the
     * representation of this date is to be set to lenient.
     * </p>
     * @return boolean
     */
    public boolean isStrictDateFormat();

    /**
     * <p>
     * Indicates whether or not this attribute requires some kind of
     * validation (the collection of validator types is not empty).
     * </p>
     * @return boolean
     */
    public boolean isValidationRequired();
}