// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.Map;
import org.andromda.metafacades.uml.FrontEndForward;

/**
 * <p>
 * Represents a forward within a JSF activity graph.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFForward
    extends FrontEndForward
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFForwardMetaType();

    /**
     * <p>
     * The name that corresponds to the from-outcome in an navigational
     * rule.
     * </p>
     * @return String
     */
    public String getFromOutcome();

    /**
     * <p>
     * The path to which this forward points.
     * </p>
     * @return String
     */
    public String getPath();

    /**
     * <p>
     * Messages used to indicate successful execution.
     * </p>
     * @return Map
     */
    public Map getSuccessMessages();

    /**
     * <p>
     * Any messages used to indicate a warning.
     * </p>
     * @return Map
     */
    public Map getWarningMessages();

    /**
     * <p>
     * Indicates whether or not a final state is the target of this
     * forward.
     * </p>
     * @return boolean
     */
    public boolean isFinalStateTarget();

    /**
     * <p>
     * Indicates whether or not any success messags are present.
     * </p>
     * @return boolean
     */
    public boolean isSuccessMessagesPresent();

    /**
     * <p>
     * Whether or not any warning messages are present.
     * </p>
     * @return boolean
     */
    public boolean isWarningMessagesPresent();
}