// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.ManageableEntity;
import org.andromda.metafacades.uml.Role;

/**
 * 
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFManageableEntity
    extends ManageableEntity
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFManageableEntityMetaType();

    /**
     * <p>
     * The name of the action class that executes the manageable
     * actions.
     * </p>
     * @return String
     */
    public String getActionClassName();

    /**
     * <p>
     * The fully qualified path to the action class that execute the
     * manageable actions.
     * </p>
     * @return String
     */
    public String getActionFullPath();

    /**
     * <p>
     * The path to the action class that execute the manageable
     * actions.
     * </p>
     * @return String
     */
    public String getActionPath();

    /**
     * 
     * @return String
     */
    public String getActionRoles();

    /**
     * <p>
     * The calcuated serial version UID for this manageable actions.
     * </p>
     * @return String
     */
    public String getActionSerialVersionUID();

    /**
     * <p>
     * The fully qualified name of the action class that execute the
     * manageable actions.
     * </p>
     * @return String
     */
    public String getActionType();

    /**
     * <p>
     * The bean name of this manageable controller (this is what is
     * stored in the JSF configuration file).
     * </p>
     * @return String
     */
    public String getControllerBeanName();

    /**
     * <p>
     * Full path of this manageable controller.
     * </p>
     * @return String
     */
    public String getControllerFullPath();

    /**
     * <p>
     * Manageable controller class name.
     * </p>
     * @return String
     */
    public String getControllerName();

    /**
     * <p>
     * Fully qualified name of this manageable controller.
     * </p>
     * @return String
     */
    public String getControllerType();

    /**
     * 
     * @return String
     */
    public String getConverterClassName();

    /**
     * 
     * @return String
     */
    public String getConverterFullPath();

    /**
     * 
     * @return String
     */
    public String getConverterType();

    /**
     * 
     * @return String
     */
    public String getExceptionKey();

    /**
     * 
     * @return String
     */
    public String getExceptionPath();

    /**
     * 
     * @return String
     */
    public String getFormBeanClassName();

    /**
     * 
     * @return String
     */
    public String getFormBeanFullPath();

    /**
     * 
     * @return String
     */
    public String getFormBeanName();

    /**
     * 
     * @return String
     */
    public String getFormBeanType();

    /**
     * <p>
     * The calcuated serial version UID for this action's form.
     * </p>
     * @return String
     */
    public String getFormSerialVersionUID();

    /**
     * 
     * @return String
     */
    public String getListGetterName();

    /**
     * 
     * @return String
     */
    public String getListName();

    /**
     * 
     * @return String
     */
    public String getListSetterName();

    /**
     * 
     * @return Collection
     */
    public Collection getManageableSearchAssociationEnds();

    /**
     * 
     * @return Collection
     */
    public Collection getManageableSearchAttributes();

    /**
     * 
     * @return String
     */
    public String getMessageKey();

    /**
     * 
     * @return String
     */
    public String getMessageValue();

    /**
     * 
     * @return String
     */
    public String getOdsExportFullPath();

    /**
     * <p>
     * The full path to this entity's online help action. The returned
     * String does not have a suffix such as '.do'.
     * </p>
     * @return String
     */
    public String getOnlineHelpActionPath();

    /**
     * <p>
     * The key to lookup the online help documentation.
     * </p>
     * @return String
     */
    public String getOnlineHelpKey();

    /**
     * <p>
     * The full path to this entitiy's online help page. The returned
     * String does not have a suffix such as '.jsp'.
     * </p>
     * @return String
     */
    public String getOnlineHelpPagePath();

    /**
     * <p>
     * The online help documentation. The format is HTML without any
     * style.
     * </p>
     * @return String
     */
    public String getOnlineHelpValue();

    /**
     * 
     * @return String
     */
    public String getPopulatorFullPath();

    /**
     * 
     * @return String
     */
    public String getPopulatorName();

    /**
     * 
     * @return String
     */
    public String getPopulatorType();

    /**
     * 
     * @return Collection<Role>
     */
    public Collection<Role> getRoles();

    /**
     * 
     * @return String
     */
    public String getSearchFormBeanClassName();

    /**
     * 
     * @return String
     */
    public String getSearchFormBeanFullPath();

    /**
     * 
     * @return String
     */
    public String getSearchFormBeanName();

    /**
     * 
     * @return String
     */
    public String getSearchFormBeanType();

    /**
     * <p>
     * Tthe available types of export in a single String instance.
     * </p>
     * @return String
     */
    public String getTableExportTypes();

    /**
     * <p>
     * The maximum number of rows to be displayed in the table at the
     * same time. This is also known as the page size. A value of zero
     * or less will display all data in the same table (therefore also
     * on the same page).
     * </p>
     * @return int
     */
    public int getTableMaxRows();

    /**
     * 
     * @return String
     */
    public String getValueObjectClassName();

    /**
     * 
     * @return String
     */
    public String getViewFullPath();

    /**
     * 
     * @return String
     */
    public String getViewName();

    /**
     * 
     * @return String
     */
    public String getViewTitleKey();

    /**
     * 
     * @return String
     */
    public String getViewTitleValue();

    /**
     * 
     * @return boolean
     */
    public boolean isNeedsFileUpload();

    /**
     * 
     * @return boolean
     */
    public boolean isNeedsUserInterface();

    /**
     * 
     * @return boolean
     */
    public boolean isPreload();

    /**
     * 
     * @param element Object
     * @return boolean
     */
    public boolean isSearchable(Object element);

    /**
     * <p>
     * True if it is possible to export the table data to XML, CSV, PDF
     * or Excel format.
     * </p>
     * @return boolean
     */
    public boolean isTableExportable();

    /**
     * <p>
     * True if it is possible to sort the columns of the table.
     * </p>
     * @return boolean
     */
    public boolean isTableSortable();

    /**
     * 
     * @return boolean
     */
    public boolean isValidationRequired();
}