// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.Collection;
import java.util.List;
import org.andromda.metafacades.uml.FrontEndParameter;

/**
 * <p>
 * Represents a parameter in a JSF front-end.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFParameter
    extends FrontEndParameter
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFParameterMetaType();

    /**
     * <p>
     * All the annotations for this parameter.
     * </p>
     * @return Collection
     */
    public Collection getAnnotations();

    /**
     * <p>
     * All attributes belonging to this parameter's type.
     * </p>
     * @return Collection
     */
    public Collection getAttributes();

    /**
     * <p>
     * The backing list name for this parameter. This is useful if you
     * want to be able to select the parameter value from a list (i.e.
     * a drop-down select input type).
     * </p>
     * @return String
     */
    public String getBackingListName();

    /**
     * <p>
     * The name of the backing value for this parameter (only used with
     * collections and arrays that are input type table).
     * </p>
     * @return String
     */
    public String getBackingValueName();

    /**
     * <p>
     * The name of the date formatter for this parameter (if this
     * parameter represents a date).
     * </p>
     * @return String
     */
    public String getDateFormatter();

    /**
     * <p>
     * A resource message key suited for the parameter's documentation.
     * </p>
     * @return String
     */
    public String getDocumentationKey();

    /**
     * <p>
     * A resource message value suited for the parameter's
     * documentation.
     * </p>
     * @return String
     */
    public String getDocumentationValue();

    /**
     * <p>
     * The dummy value for this parameter. The dummy value is used for
     * setting the dummy information when dummyData is enabled.
     * </p>
     * @return String
     */
    public String getDummyValue();

    /**
     * <p>
     * The name of the property used for indicating whether or not a
     * form attribute has been set at least once.
     * </p>
     * @return String
     */
    public String getFormAttributeSetProperty();

    /**
     * <p>
     * If this parameter represents a date or time this method will
     * return the format in which it must be represented. In the event
     * this format has not been specified by the any tagged value the
     * default will be used.
     * </p>
     * @return String
     */
    public String getFormat();

    /**
     * <p>
     * A comma separated list of the input table identifier columns
     * (these are the columns that uniquely define a row in an input
     * table).
     * </p>
     * @return String
     */
    public String getInputTableIdentifierColumns();

    /**
     * <p>
     * The name of the label list for this parameter. The label list
     * name is the name of the list storing the labels for the possible
     * values of this parameter (typically used for the labels of a
     * drop-down select lists).
     * </p>
     * @return String
     */
    public String getLabelListName();

    /**
     * <p>
     * The max length allowed in the input component
     * </p>
     * @return String
     */
    public String getMaxLength();

    /**
     * <p>
     * The default message key for this parameter.
     * </p>
     * @return String
     */
    public String getMessageKey();

    /**
     * <p>
     * The default message value for this parameter.
     * </p>
     * @return String
     */
    public String getMessageValue();

    /**
     * <p>
     * All navigation association ends belonging to this parameter's
     * type.
     * </p>
     * @return Collection
     */
    public Collection getNavigableAssociationEnds();

    /**
     * <p>
     * Those actions that are targetting the given column, only makes
     * sense when this parameter represents a table view-variable.
     * </p>
     * @param columnName String
     * @return List
     */
    public List getTableColumnActions(String columnName);

    /**
     * 
     * @param columnName String
     * @return String
     */
    public String getTableColumnMessageKey(String columnName);

    /**
     * 
     * @param columnName String
     * @return String
     */
    public String getTableColumnMessageValue(String columnName);

    /**
     * <p>
     * Actions used when submitting forms for this table. Table actions
     * that are hyperlinks are not included. It only makes sense to
     * call this property on parameters that represent a table
     * page-variable.
     * </p>
     * @return List<JSFAction>
     */
    public List<JSFAction> getTableFormActions();

    /**
     * <p>
     * Actions that are working with this table and are to be
     * represented as hyperlinks. This only makes sense on a parameter
     * that represents a table page variable.
     * </p>
     * @return List<JSFAction>
     */
    public List<JSFAction> getTableHyperlinkActions();

    /**
     * <p>
     * The name of the property that Indicates whether or not the table
     * should be sorted ascending (if this parameter represents a
     * table).
     * </p>
     * @return String
     */
    public String getTableSortAscendingProperty();

    /**
     * <p>
     * The name of the property storing the column to sort by if this
     * parameter represents a table.
     * </p>
     * @return String
     */
    public String getTableSortColumnProperty();

    /**
     * <p>
     * The name of the time formatter (if this parameter represents a
     * time).
     * </p>
     * @return String
     */
    public String getTimeFormatter();

    /**
     * <p>
     * The validator's 'validwhen' value, this is useful when the
     * validation of a parameter depends on the validation of others.
     * See the apache commons-validator documentation for more
     * information.
     * </p>
     * @return String
     */
    public String getValidWhen();

    /**
     * <p>
     * Gets the arguments for this parameter's validators.
     * </p>
     * @param validatorType String
     * @return Collection
     */
    public Collection getValidatorArgs(String validatorType);

    /**
     * <p>
     * All the validator types for this parameter.
     * </p>
     * @return Collection
     */
    public Collection getValidatorTypes();

    /**
     * <p>
     * The validator variables.
     * </p>
     * @return Collection
     */
    public Collection getValidatorVars();

    /**
     * <p>
     * The dummy value for a value list.
     * </p>
     * @return String
     */
    public String getValueListDummyValue();

    /**
     * <p>
     * Stores the name of the value list for this parameter; this list
     * stores the possible values that this parameter may be (typically
     * used for the values of a drop-down select list).
     * </p>
     * @return String
     */
    public String getValueListName();

    /**
     * <p>
     * Indicates if a backing value is required for this parameter.
     * </p>
     * @return boolean
     */
    public boolean isBackingValueRequired();

    /**
     * <p>
     * Indicates if this parameter is 'complex', that is: its of a
     * complex type (has at least one attribute or association).
     * </p>
     * @return boolean
     */
    public boolean isComplex();

    /**
     * <p>
     * Indicates whether or not this parameter uses the equal
     * validator.
     * </p>
     * @return boolean
     */
    public boolean isEqualValidator();

    /**
     * <p>
     * Indicates if this parameter represents a checkbox widget.
     * </p>
     * @return boolean
     */
    public boolean isInputCheckbox();

    /**
     * <p>
     * Indicates whether or not this is a file input type.
     * </p>
     * @return boolean
     */
    public boolean isInputFile();

    /**
     * <p>
     * Indicates whether or not this parameter represents a hidden
     * input widget.
     * </p>
     * @return boolean
     */
    public boolean isInputHidden();

    /**
     * <p>
     * Indicates whether or not this type represents an input multibox.
     * </p>
     * @return boolean
     */
    public boolean isInputMultibox();

    /**
     * <p>
     * Indicates whether or not this parameter should be rendered as an
     * input radio widget.
     * </p>
     * @return boolean
     */
    public boolean isInputRadio();

    /**
     * <p>
     * Indicates whether or not this parameter represents an input
     * "secret" widget (i.e. password).
     * </p>
     * @return boolean
     */
    public boolean isInputSecret();

    /**
     * <p>
     * Indicates whether or not this parameter represents an input
     * select widget.
     * </p>
     * @return boolean
     */
    public boolean isInputSelect();

    /**
     * <p>
     * Indicates whether or not this is an table input type.
     * </p>
     * @return boolean
     */
    public boolean isInputTable();

    /**
     * <p>
     * Indicates whether or not this parameter should be rendered as a
     * text input widget.
     * </p>
     * @return boolean
     */
    public boolean isInputText();

    /**
     * <p>
     * Indicates if this parameter represents as an input text area
     * widget.
     * </p>
     * @return boolean
     */
    public boolean isInputTextarea();

    /**
     * <p>
     * Whether or not the parameter is a "pageable table", that is a
     * table that supports paging (i.e. DB paging).
     * </p>
     * @return boolean
     */
    public boolean isPageableTable();

    /**
     * <p>
     * Indicates whether or not this field should be rendered as plain
     * text (not as a widget).
     * </p>
     * @return boolean
     */
    public boolean isPlaintext();

    /**
     * <p>
     * Indicates if this parameter can only be read and not modified.
     * </p>
     * @return boolean
     */
    public boolean isReadOnly();

    /**
     * <p>
     * Indicates if this parameter's value should be reset or not after
     * an action has been performed with this parameter.
     * </p>
     * @return boolean
     */
    public boolean isReset();

    /**
     * <p>
     * Indicates whether or not this parameter is selectable or not
     * (that is: it can be selected from a list of values).
     * </p>
     * @return boolean
     */
    public boolean isSelectable();

    /**
     * <p>
     * Indicates where or not the date format is to be strictly
     * respected. Otherwise the date formatter used for the
     * representation of this date is to be set to lenient.
     * </p>
     * @return boolean
     */
    public boolean isStrictDateFormat();

    /**
     * <p>
     * Indicates whether or not this parameter requires some kind of
     * validation (the collection of validator types is not empty).
     * </p>
     * @return boolean
     */
    public boolean isValidationRequired();
}