// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import org.andromda.metafacades.uml.FrontEndUseCase;

/**
 * <p>
 * Represents a JSF use case.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFUseCase
    extends FrontEndUseCase
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFUseCaseMetaType();

    /**
     * <p>
     * The name of the action class that forwards to this use case.
     * </p>
     * @return String
     */
    public String getActionClassName();

    /**
     * <p>
     * All forwards in this use case that are represented as actions.
     * </p>
     * @return List<JSFAction>
     */
    public List<JSFAction> getActionForwards();

    /**
     * 
     * @return String
     */
    public String getActionRoles();

    /**
     * <p>
     * Constains all forwards includes regular FrontEndForwards and all
     * actiion forwards.
     * </p>
     * @return List
     */
    public List getAllForwards();

    /**
     * <p>
     * A map with keys sorted alphabetically, normalized across all
     * different use-cases, views, etc.
     * </p>
     * @return Map
     */
    public Map getAllMessages();

    /**
     * <p>
     * All views for the application (not just the ones belonging to
     * this use case).
     * </p>
     * @return Collection<JSFView>
     */
    public Collection<JSFView> getAllViews();

    /**
     * <p>
     * The name of the action on the controller that executions this
     * use case.
     * </p>
     * @return String
     */
    public String getControllerAction();

    /**
     * <p>
     * The key under which to store the action form passed along in
     * this in this use-case.
     * </p>
     * @return String
     */
    public String getFormKey();

    /**
     * <p>
     * The name that will cause a forward to use case.
     * </p>
     * @return String
     */
    public String getForwardName();

    /**
     * <p>
     * All forwards contained in this use case.
     * </p>
     * @return List<JSFForward>
     */
    public List<JSFForward> getForwards();

    /**
     * <p>
     * The name of the class that stores all the forwards paths.
     * </p>
     * @return String
     */
    public String getForwardsClassName();

    /**
     * <p>
     * The fully qualified name of the action class that forwards to
     * this use case.
     * </p>
     * @return String
     */
    public String getFullyQualifiedActionClassName();

    /**
     * <p>
     * The fully qualified path to the action class that forwards to
     * this use case.
     * </p>
     * @return String
     */
    public String getFullyQualifiedActionClassPath();

    /**
     * <p>
     * The path of the initial target going into this use case.
     * </p>
     * @return String
     */
    public String getInitialTargetPath();

    /**
     * 
     * @return Collection
     */
    public Collection getNavigationChildren();

    /**
     * 
     * @return Collection
     */
    public Collection getNavigationParents();

    /**
     * <p>
     * Retrieves all navigation rules for the faces-config.xml
     * </p>
     * @return Collection
     */
    public Collection getNavigationRules();

    /**
     * <p>
     * The path to which this use case points.
     * </p>
     * @return String
     */
    public String getPath();

    /**
     * <p>
     * The root path for this use case (this is the path the directory
     * containing the use case's resources).
     * </p>
     * @return String
     */
    public String getPathRoot();

    /**
     * <p>
     * The forward name for the portlet 'edit' page.
     * </p>
     * @return String
     */
    public String getPortletEditForwardName();

    /**
     * <p>
     * The path to the portlet 'edit' page.
     * </p>
     * @return String
     */
    public String getPortletEditPath();

    /**
     * <p>
     * The forward name for the portlet 'help' page.
     * </p>
     * @return String
     */
    public String getPortletHelpForwardName();

    /**
     * <p>
     * The path to the 'help' page of the portlet.
     * </p>
     * @return String
     */
    public String getPortletHelpPath();

    /**
     * <p>
     * The forward name for the portlet 'view' page.
     * </p>
     * @return String
     */
    public String getPortletViewForwardName();

    /**
     * <p>
     * The path to the portlet 'view' page.
     * </p>
     * @return String
     */
    public String getPortletViewPath();

    /**
     * <p>
     * Any portlet preferences associated to this use case.
     * </p>
     * @return JSFPortletPreferences
     */
    public JSFPortletPreferences getPreferences();

    /**
     * <p>
     * All use cases that are labled as registration use cases.
     * </p>
     * @return List<JSFUseCase>
     */
    public List<JSFUseCase> getRegistrationUseCases();

    /**
     * <p>
     * The title message key for this use-case.
     * </p>
     * @return String
     */
    public String getTitleKey();

    /**
     * <p>
     * The title message value for this use-case.
     * </p>
     * @return String
     */
    public String getTitleValue();

    /**
     * <p>
     * Indicates that at least one client/server parameter found in the
     * collection of existing use-cases requires validation.
     * </p>
     * @return boolean
     */
    public boolean isApplicationValidationRequired();

    /**
     * <p>
     * Indicates whether or not the initial target of this use case is
     * a view or not.
     * </p>
     * @return boolean
     */
    public boolean isInitialTargetView();

    /**
     * <p>
     * Indicates whether or not this is a front-end registration use
     * case.  Only one use case can be labeled as a 'registration' use
     * case.
     * </p>
     * @return boolean
     */
    public boolean isRegistrationUseCase();

    /**
     * <p>
     * Indicates whether or not at least one parameter in this use-case
     * require validation.
     * </p>
     * @return boolean
     */
    public boolean isValidationRequired();

    /**
     * <p>
     * Indicates whether or not at least one view in the use case has
     * the same name as this use case.
     * </p>
     * @return boolean
     */
    public boolean isViewHasNameOfUseCase();
}