// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.jsf.metafacades;

import java.util.List;
import org.andromda.metafacades.uml.FrontEndView;

/**
 * <p>
 * Represents a JSF view for a front-end application.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface JSFView
    extends FrontEndView
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isJSFViewMetaType();

    /**
     * <p>
     * All those forwards that are actions.
     * </p>
     * @return List<JSFAction>
     */
    public List<JSFAction> getActionForwards();

    /**
     * <p>
     * All variables that have backing value.
     * </p>
     * @return List<JSFParameter>
     */
    public List<JSFParameter> getBackingValueVariables();

    /**
     * <p>
     * A resource message key suited for the page's documentation.
     * </p>
     * @return String
     */
    public String getDocumentationKey();

    /**
     * <p>
     * A resource message value suited for the view's documentation.
     * </p>
     * @return String
     */
    public String getDocumentationValue();

    /**
     * <p>
     * All actions that have forms associated with them.
     * </p>
     * @return List<JSFAction>
     */
    public List<JSFAction> getFormActions();

    /**
     * <p>
     * The key that stores the form in which information is passed from
     * one action to another.
     * </p>
     * @return String
     */
    public String getFormKey();

    /**
     * <p>
     * Gets the forwards which can be targgeted from this view.
     * </p>
     * @return List<JSFForward>
     */
    public List<JSFForward> getForwards();

    /**
     * <p>
     * The name that corresponds to the from-outcome in an navigational
     * rule.
     * </p>
     * @return String
     */
    public String getFromOutcome();

    /**
     * <p>
     * The fully qualified name of this view's form populator.
     * </p>
     * @return String
     */
    public String getFullyQualifiedPopulator();

    /**
     * <p>
     * The default resource message key for this view.
     * </p>
     * @return String
     */
    public String getMessageKey();

    /**
     * <p>
     * A displayable version of this view's name.
     * </p>
     * @return String
     */
    public String getMessageValue();

    /**
     * <p>
     * The full path of the view resources (i.e. the JSP page).
     * </p>
     * @return String
     */
    public String getPath();

    /**
     * <p>
     * The name of the form populator for this view.
     * </p>
     * @return String
     */
    public String getPopulator();

    /**
     * <p>
     * The path to the form populator.
     * </p>
     * @return String
     */
    public String getPopulatorPath();

    /**
     * <p>
     * A resource message key suited for the view's title.
     * </p>
     * @return String
     */
    public String getTitleKey();

    /**
     * <p>
     * A default resource message value suited for the page's title.
     * </p>
     * @return String
     */
    public String getTitleValue();

    /**
     * <p>
     * Indicates whether or not this view has the same name as the use
     * case in which it is contained.
     * </p>
     * @return boolean
     */
    public boolean isHasNameOfUseCase();

    /**
     * 
     * @return boolean
     */
    public boolean isNeedsFileUpload();

    /**
     * <p>
     * Indicates whether or not any non-table view variables are
     * present in this view.
     * </p>
     * @return boolean
     */
    public boolean isNonTableVariablesPresent();

    /**
     * <p>
     * Indicates if a populator is required for this view.
     * </p>
     * @return boolean
     */
    public boolean isPopulatorRequired();

    /**
     * <p>
     * Indicates if this view represents a popup.
     * </p>
     * @return boolean
     */
    public boolean isPopup();

    /**
     * <p>
     * Indicates whether or not at least one parameter of an outgoing
     * action in this view requires validation.
     * </p>
     * @return boolean
     */
    public boolean isValidationRequired();
}